<?php

namespace App\Repositories\Core\User\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;

class NewUser extends Notification
{
    use Queueable;

    /**
     * Get the notification's delivery channels.
     *
     * @param mixed $notifiable
     *
     * @return string[]
     */
    public function via($notifiable)
    {
        return ['mail'];
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     *
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        $currentUser = \Auth::user();

        return (new MailMessage())
            ->markdown('notifications.email')
            ->greeting(__('notifications.greeting', ['firstname' => $notifiable->first_name]))
            ->subject(__('notifications.newuser.subject', ['name' => config('app.name')]))
            ->line(
                __(
                    'notifications.newuser.intro', [
                    'name' => $currentUser->first_name.' '.$currentUser->last_name,
                    ]
                )
            )
            ->action(
                __('notifications.newuser.button'),
                route('users.firstlogin', $notifiable->remember_token)
            )
            ->salutation(
                __(
                    'notifications.salutation', [
                    'name' => $currentUser->first_name.' '.$currentUser->last_name,
                    ]
                )
            )
            ->line(__('notifications.newuser.outro'));
    }

    /**
     * Get the array representation of the notification.
     *
     * @param mixed $notifiable
     *
     * @return array
     */
    public function toArray($notifiable)
    {
        return [
            //
        ];
    }
}
